



















































import torch
import torch.nn as nn
import torch.optim as optim
from torchvision import datasets, transforms
from torch.utils.data import DataLoader
import argparse

parser = argparse.ArgumentParser(description="A simple example.")
parser.add_argument('--batch', type=int, default=1024, help="train epochs")
parser.add_argument('--epochs', type=int, default=150, help="train epochs")
args = parser.parse_args()

device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')


class SimpleNN(nn.Module):
    def __init__(self):
        super(SimpleNN, self).__init__()
        self.fc1 = nn.Linear(28*28, 16384)  
        self.fc2 = nn.Linear(16384, 16384) 
        self.fc3 = nn.Linear(16384, 16384)
        self.fc4 = nn.Linear(16384, 16384)
        self.fc5 = nn.Linear(16384, 16384)
        self.fc6 = nn.Linear(16384, 16384)
        self.fc7 = nn.Linear(16384, 16384)
        self.fc8 = nn.Linear(16384, 16384)     
        self.fc9 = nn.Linear(16384, 10)       

    def forward(self, x):
        x = x.view(-1, 28*28) 
        x = torch.relu(self.fc1(x)) 
        x = torch.relu(self.fc2(x))
        x = torch.relu(self.fc3(x))
        x = torch.relu(self.fc4(x))
        x = torch.relu(self.fc5(x))
        x = torch.relu(self.fc6(x))
        x = torch.relu(self.fc7(x))
        x = torch.relu(self.fc8(x))
        x = self.fc9(x)
        return x


batch_size = args.batch
learning_rate = 0.001
epochs = args.epochs

transform = transforms.Compose([
    transforms.ToTensor(),
    transforms.Normalize((0.5,), (0.5,))
])

train_dataset = datasets.MNIST(root='./data', train=True, download=True, transform=transform)
train_loader = DataLoader(train_dataset, batch_size=batch_size, shuffle=True)

model = SimpleNN().to(device)
criterion = nn.CrossEntropyLoss()
optimizer = optim.Adam(model.parameters(), lr=learning_rate)

for epoch in range(epochs):
    model.train()
    running_loss = 0.0
    for images, labels in train_loader:
        images, labels = images.to(device), labels.to(device)

        optimizer.zero_grad()
        outputs = model(images)
        loss = criterion(outputs, labels)
        loss.backward()
        optimizer.step()

        running_loss += loss.item()
    

print("done")
