

from transformers import FSMTConfig, FSMTForConditionalGeneration, FSMTTokenizer


mname = "facebook/wmt19-en-de"
tokenizer = FSMTTokenizer.from_pretrained(mname)
config = FSMTConfig.from_pretrained(mname)
config.update({
    "d_model": 4,
    "encoder_layers": 1, "decoder_layers": 1,
    "encoder_ffn_dim": 4, "decoder_ffn_dim": 4,
    "encoder_attention_heads": 1, "decoder_attention_heads": 1})

tiny_model = FSMTForConditionalGeneration(config)
print(f"num of params {tiny_model.num_parameters()}")

batch = tokenizer(["Making tiny model"], return_tensors="pt")
outputs = tiny_model(**batch)

print("test output:", len(outputs.logits[0]))

mname_tiny = "tiny-wmt19-en-de"
tiny_model.half() tiny_model.save_pretrained(mname_tiny)
tokenizer.save_pretrained(mname_tiny)

print(f"Generated {mname_tiny}")

