
















from ..models.whisper import WhisperForConditionalGeneration, WhisperProcessor
from .tools import PipelineTool


class SpeechToTextTool(PipelineTool):
    default_checkpoint = "distil-whisper/distil-large-v3"
    description = "This is a tool that transcribes an audio into text. It returns the transcribed text."
    name = "transcriber"
    pre_processor_class = WhisperProcessor
    model_class = WhisperForConditionalGeneration

    inputs = {"audio": {"type": "audio", "description": "The audio to transcribe"}}
    output_type = "text"

    def encode(self, audio):
        return self.pre_processor(audio, return_tensors="pt")

    def forward(self, inputs):
        return self.model.generate(inputs["input_features"])

    def decode(self, outputs):
        return self.pre_processor.batch_decode(outputs, skip_special_tokens=True)[0]
