












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available


_import_structure = {
    "configuration_audio_spectrogram_transformer": ["ASTConfig"],
    "feature_extraction_audio_spectrogram_transformer": ["ASTFeatureExtractor"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_audio_spectrogram_transformer"] = [
        "ASTForAudioClassification",
        "ASTModel",
        "ASTPreTrainedModel",
    ]


if TYPE_CHECKING:
    from .configuration_audio_spectrogram_transformer import (
        ASTConfig,
    )
    from .feature_extraction_audio_spectrogram_transformer import ASTFeatureExtractor

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_audio_spectrogram_transformer import (
            ASTForAudioClassification,
            ASTModel,
            ASTPreTrainedModel,
        )


else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
