












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_tokenizers_available, is_torch_available


_import_structure = {
    "configuration_biogpt": ["BioGptConfig"],
    "tokenization_biogpt": ["BioGptTokenizer"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_biogpt"] = [
        "BioGptForCausalLM",
        "BioGptForTokenClassification",
        "BioGptForSequenceClassification",
        "BioGptModel",
        "BioGptPreTrainedModel",
    ]


if TYPE_CHECKING:
    from .configuration_biogpt import BioGptConfig
    from .tokenization_biogpt import BioGptTokenizer

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_biogpt import (
            BioGptForCausalLM,
            BioGptForSequenceClassification,
            BioGptForTokenClassification,
            BioGptModel,
            BioGptPreTrainedModel,
        )


else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
