












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_tokenizers_available, is_torch_available


_import_structure = {
    "configuration_bros": ["BrosConfig"],
}

try:
    if not is_tokenizers_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["processing_bros"] = ["BrosProcessor"]

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_bros"] = [
        "BrosPreTrainedModel",
        "BrosModel",
        "BrosForTokenClassification",
        "BrosSpadeEEForTokenClassification",
        "BrosSpadeELForTokenClassification",
    ]


if TYPE_CHECKING:
    from .configuration_bros import BrosConfig

    try:
        if not is_tokenizers_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .processing_bros import BrosProcessor

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_bros import (
            BrosForTokenClassification,
            BrosModel,
            BrosPreTrainedModel,
            BrosSpadeEEForTokenClassification,
            BrosSpadeELForTokenClassification,
        )


else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
