












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_tokenizers_available, is_torch_available


_import_structure = {
    "configuration_canine": ["CanineConfig"],
    "tokenization_canine": ["CanineTokenizer"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_canine"] = [
        "CanineForMultipleChoice",
        "CanineForQuestionAnswering",
        "CanineForSequenceClassification",
        "CanineForTokenClassification",
        "CanineLayer",
        "CanineModel",
        "CaninePreTrainedModel",
        "load_tf_weights_in_canine",
    ]


if TYPE_CHECKING:
    from .configuration_canine import CanineConfig
    from .tokenization_canine import CanineTokenizer

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_canine import (
            CanineForMultipleChoice,
            CanineForQuestionAnswering,
            CanineForSequenceClassification,
            CanineForTokenClassification,
            CanineLayer,
            CanineModel,
            CaninePreTrainedModel,
            load_tf_weights_in_canine,
        )


else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
