












from typing import TYPE_CHECKING

from ...utils import (
    OptionalDependencyNotAvailable,
    _LazyModule,
    is_torch_available,
)


_import_structure = {
    "configuration_encodec": ["EncodecConfig"],
    "feature_extraction_encodec": ["EncodecFeatureExtractor"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_encodec"] = [
        "EncodecModel",
        "EncodecPreTrainedModel",
    ]

if TYPE_CHECKING:
    from .configuration_encodec import (
        EncodecConfig,
    )
    from .feature_extraction_encodec import EncodecFeatureExtractor

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_encodec import (
            EncodecModel,
            EncodecPreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
