












from typing import TYPE_CHECKING


from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available


_import_structure = {"configuration_focalnet": ["FocalNetConfig"]}


try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_focalnet"] = [
        "FocalNetForImageClassification",
        "FocalNetForMaskedImageModeling",
        "FocalNetBackbone",
        "FocalNetModel",
        "FocalNetPreTrainedModel",
    ]

if TYPE_CHECKING:
    from .configuration_focalnet import FocalNetConfig

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_focalnet import (
            FocalNetBackbone,
            FocalNetForImageClassification,
            FocalNetForMaskedImageModeling,
            FocalNetModel,
            FocalNetPreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
