












from typing import TYPE_CHECKING

from ...utils import (
    OptionalDependencyNotAvailable,
    _LazyModule,
    is_torch_available,
    is_vision_available,
)


_import_structure = {
    "configuration_mobilevitv2": [
        "MobileViTV2Config",
        "MobileViTV2OnnxConfig",
    ],
}


try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_mobilevitv2"] = [
        "MobileViTV2ForImageClassification",
        "MobileViTV2ForSemanticSegmentation",
        "MobileViTV2Model",
        "MobileViTV2PreTrainedModel",
    ]

if TYPE_CHECKING:
    from .configuration_mobilevitv2 import (
        MobileViTV2Config,
        MobileViTV2OnnxConfig,
    )

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_mobilevitv2 import (
            MobileViTV2ForImageClassification,
            MobileViTV2ForSemanticSegmentation,
            MobileViTV2Model,
            MobileViTV2PreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
