
















from typing import TYPE_CHECKING


from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_tokenizers_available, is_torch_available


_import_structure = {"configuration_mra": ["MraConfig"]}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_mra"] = [
        "MraForMaskedLM",
        "MraForMultipleChoice",
        "MraForQuestionAnswering",
        "MraForSequenceClassification",
        "MraForTokenClassification",
        "MraLayer",
        "MraModel",
        "MraPreTrainedModel",
    ]


if TYPE_CHECKING:
    from .configuration_mra import MraConfig

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_mra import (
            MraForMaskedLM,
            MraForMultipleChoice,
            MraForQuestionAnswering,
            MraForSequenceClassification,
            MraForTokenClassification,
            MraLayer,
            MraModel,
            MraPreTrainedModel,
        )
else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure)
