












from typing import TYPE_CHECKING


from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available


_import_structure = {
    "configuration_patchtsmixer": ["PatchTSMixerConfig"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_patchtsmixer"] = [
        "PatchTSMixerPreTrainedModel",
        "PatchTSMixerModel",
        "PatchTSMixerForPretraining",
        "PatchTSMixerForPrediction",
        "PatchTSMixerForTimeSeriesClassification",
        "PatchTSMixerForRegression",
    ]


if TYPE_CHECKING:
    from .configuration_patchtsmixer import (
        PatchTSMixerConfig,
    )

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_patchtsmixer import (
            PatchTSMixerForPrediction,
            PatchTSMixerForPretraining,
            PatchTSMixerForRegression,
            PatchTSMixerForTimeSeriesClassification,
            PatchTSMixerModel,
            PatchTSMixerPreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
