












from typing import TYPE_CHECKING


from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available


_import_structure = {
    "configuration_patchtst": ["PatchTSTConfig"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_patchtst"] = [
        "PatchTSTModel",
        "PatchTSTPreTrainedModel",
        "PatchTSTForPrediction",
        "PatchTSTForPretraining",
        "PatchTSTForRegression",
        "PatchTSTForClassification",
    ]


if TYPE_CHECKING:
    from .configuration_patchtst import PatchTSTConfig

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_patchtst import (
            PatchTSTForClassification,
            PatchTSTForPrediction,
            PatchTSTForPretraining,
            PatchTSTForRegression,
            PatchTSTModel,
            PatchTSTPreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
