












from typing import TYPE_CHECKING

from ...utils import (
    OptionalDependencyNotAvailable,
    _LazyModule,
    is_torch_available,
)


_import_structure = {
    "configuration_seamless_m4t_v2": ["SeamlessM4Tv2Config"],
}

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_seamless_m4t_v2"] = [
        "SeamlessM4Tv2ForTextToSpeech",
        "SeamlessM4Tv2ForSpeechToSpeech",
        "SeamlessM4Tv2ForTextToText",
        "SeamlessM4Tv2ForSpeechToText",
        "SeamlessM4Tv2Model",
        "SeamlessM4Tv2PreTrainedModel",
    ]

if TYPE_CHECKING:
    from .configuration_seamless_m4t_v2 import SeamlessM4Tv2Config

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_seamless_m4t_v2 import (
            SeamlessM4Tv2ForSpeechToSpeech,
            SeamlessM4Tv2ForSpeechToText,
            SeamlessM4Tv2ForTextToSpeech,
            SeamlessM4Tv2ForTextToText,
            SeamlessM4Tv2Model,
            SeamlessM4Tv2PreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
