












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available, is_vision_available


_import_structure = {
    "configuration_video_llava": ["VideoLlavaConfig"],
    "processing_video_llava": ["VideoLlavaProcessor"],
}

try:
    if not is_vision_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["image_processing_video_llava"] = ["VideoLlavaImageProcessor"]

try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_video_llava"] = [
        "VideoLlavaPreTrainedModel",
        "VideoLlavaForConditionalGeneration",
    ]

if TYPE_CHECKING:
    from .configuration_video_llava import (
        VideoLlavaConfig,
    )
    from .image_processing_video_llava import VideoLlavaProcessor

    try:
        if not is_vision_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .image_processing_video_llava import VideoLlavaImageProcessor

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_video_llava import (
            VideoLlavaForConditionalGeneration,
            VideoLlavaPreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
