












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available


_import_structure = {"configuration_vipllava": ["VipLlavaConfig"]}


try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_vipllava"] = [
        "VipLlavaForConditionalGeneration",
        "VipLlavaPreTrainedModel",
    ]


if TYPE_CHECKING:
    from .configuration_vipllava import VipLlavaConfig

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_vipllava import (
            VipLlavaForConditionalGeneration,
            VipLlavaPreTrainedModel,
        )


else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure)
