












from typing import TYPE_CHECKING

from ...utils import OptionalDependencyNotAvailable, _LazyModule, is_torch_available


_import_structure = {
    "configuration_wav2vec2_conformer": ["Wav2Vec2ConformerConfig"],
}


try:
    if not is_torch_available():
        raise OptionalDependencyNotAvailable()
except OptionalDependencyNotAvailable:
    pass
else:
    _import_structure["modeling_wav2vec2_conformer"] = [
        "Wav2Vec2ConformerForAudioFrameClassification",
        "Wav2Vec2ConformerForCTC",
        "Wav2Vec2ConformerForPreTraining",
        "Wav2Vec2ConformerForSequenceClassification",
        "Wav2Vec2ConformerForXVector",
        "Wav2Vec2ConformerModel",
        "Wav2Vec2ConformerPreTrainedModel",
    ]

if TYPE_CHECKING:
    from .configuration_wav2vec2_conformer import (
        Wav2Vec2ConformerConfig,
    )

    try:
        if not is_torch_available():
            raise OptionalDependencyNotAvailable()
    except OptionalDependencyNotAvailable:
        pass
    else:
        from .modeling_wav2vec2_conformer import (
            Wav2Vec2ConformerForAudioFrameClassification,
            Wav2Vec2ConformerForCTC,
            Wav2Vec2ConformerForPreTraining,
            Wav2Vec2ConformerForSequenceClassification,
            Wav2Vec2ConformerForXVector,
            Wav2Vec2ConformerModel,
            Wav2Vec2ConformerPreTrainedModel,
        )

else:
    import sys

    sys.modules[__name__] = _LazyModule(__name__, globals()["__file__"], _import_structure, module_spec=__spec__)
