
import unittest

import numpy as np

from transformers import load_tool

from .test_tools_common import ToolTesterMixin


class SpeechToTextToolTester(unittest.TestCase, ToolTesterMixin):
    def setUp(self):
        self.tool = load_tool("speech_to_text")
        self.tool.setup()

    def test_exact_match_arg(self):
        result = self.tool(np.ones(3000))
        self.assertEqual(result, " Thank you.")

    def test_exact_match_kwarg(self):
        result = self.tool(audio=np.ones(3000))
        self.assertEqual(result, " Thank you.")
