
import unittest

from transformers import load_tool
from transformers.utils import is_torch_available


if is_torch_available():
    import torch

from transformers.testing_utils import require_torch

from .test_tools_common import ToolTesterMixin


@require_torch
class TextToSpeechToolTester(unittest.TestCase, ToolTesterMixin):
    def setUp(self):
        self.tool = load_tool("text_to_speech")
        self.tool.setup()

    def test_exact_match_arg(self):
                torch.manual_seed(0)
        result = self.tool("hey")
        resulting_tensor = result.to_raw()
        self.assertTrue(len(resulting_tensor.detach().shape) == 1)
        self.assertTrue(resulting_tensor.detach().shape[0] > 1000)

    def test_exact_match_kwarg(self):
                torch.manual_seed(0)
        result = self.tool("hey")
        resulting_tensor = result.to_raw()
        self.assertTrue(len(resulting_tensor.detach().shape) == 1)
        self.assertTrue(resulting_tensor.detach().shape[0] > 1000)
