import argparse
import importlib
from pathlib import Path


FILES_TO_FIND = [
    "kernels/rwkv/wkv_cuda.cu",
    "kernels/rwkv/wkv_op.cpp",
    "kernels/deformable_detr/ms_deform_attn.h",
    "kernels/deformable_detr/cuda/ms_deform_im2col_cuda.cuh",
    "models/graphormer/algos_graphormer.pyx",
]


def test_custom_files_are_present(transformers_path):
        for file in FILES_TO_FIND:
        if not (transformers_path / file).exists():
            return False
    return True


if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument("--check_lib", action="store_true", help="Whether to check the build or the actual package.")
    args = parser.parse_args()
    if args.check_lib:
        transformers_module = importlib.import_module("transformers")
        transformers_path = Path(transformers_module.__file__).parent
    else:
        transformers_path = Path.cwd() / "build/lib/transformers"
    if not test_custom_files_are_present(transformers_path):
        raise ValueError("The built release does not contain the custom files. Fix this before going further!")
